#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#ifdef __IBMCPP__
  #include <memory.h>
#else
  #include <mem.h>
#endif
#include <math.h>


#define NoOut

#if !defined (NoOut)
	#include <fstream.h>
#endif


#undef huge

#define huge
#define farmalloc malloc
#define farfree free
#define cprintf printf

int checkmap(int i,int j, int *map, int &count);
int fndpos(int *ICOL, int row, int col);
void solvemat(int size, double huge *a, double *x, double *b, int *ICOL);
float XX(float x, float y, float z);
float YY(float x, float y, float z);
								
	float AS ,AP;


int main(void){
	time_t T1, T2;

	float sizex, sizey, dx, dy;
	int numx, numy,diff;
	float *xx, *xx1;
	float *yy, *yy1;
	float *temp, *Qj, *H, *K, tinfnt;
	float kval,hval;
	int k, i, j, num_unknowns;
	unsigned char *BC, *NODE_TYPE;
	float mltx, mlty, heat_in, heat_out;
	int *map, cnt, tmp, row, col, tmp2;
	int *ICOL;
	double huge *A;
	double *B;
	double *X;
	float x,y,z;
	float xxmax, yymax, xxmin, yymin;
	float axisx,axisy,axisz;
	float xxt[2],yyt[2],xxx[2],yyx[2],xxy[2],yyy[2],xxz[2],yyz[2];
	char *format;




	AS=(-4.537843);
	AP=3.05432;


	numx=7;
	numy=3;

	cprintf("Enter the number of nodes in the X-direction\n\rin the Y-direction (seperatted by a space)\n\r");
	scanf("%i %i", &numx,&numy);
	cprintf("\n\rEnter the value of k H\n\r");
	scanf("%f %f",&kval,&hval);

	sizex=0.06;
	sizey=0.02;
	dx=sizex / (numx-1);
	dy=sizey / (float) (numy-1);

	temp= new float [(numx+2)*(numy+2)] ; //(0);
	K= new float [numx*numy] ; //(0.5);
	Qj= new float [numx*numy] ; //(0);
	BC= new unsigned char [(numx+2)*(numy+2)] ; //(0);
	H= new float [numx*numy] ; //(0);
	NODE_TYPE= new unsigned char [numx*numy] ; //(0);

	for(i=0;i<numx*numy;i++){
		*(K+i)=0.5;
		*(Qj+i)=0;
		*(H+i)=0;
		*(NODE_TYPE+i)=0;
	}

	for(i=0;i<(numx+2)*(numy+2);i++){
		*(temp+i)=0;
		*(BC+i)=0;
	}

	if ((temp==NULL)||(K==NULL)||(Qj==NULL)||
		(BC==NULL)||(H==NULL)){
		printf("error in mememory allocation");
		exit(0);
	}

	for(j=0;j<numy;j++)
		for(i=0;i<numx;i++){
			Qj[i+j*numx]=0.0;
			K[i+j*numx]=kval;
			H[i+j*numx]=0.0;
			NODE_TYPE[i+j*numx]=4;
		}
	memset(BC,0, sizeof(char)*((numx+2)*(numy+2)));
	memset(temp,0, sizeof(float)*((numx+2)*(numy+2)));

// set the boundry conditions, node types and known temperatures ...

// left boundry conditions
	for(j=0;j<numy+1;j++)
		BC[j*(numx+2)]=2;		// convection
	for(j=0;j<numy+1;j++)
		temp[j*(numx+2)]=400;	//temperature of air
	for(j=0;j<numy;j++)
		H[j*numx]=500;	 		// H value for left face
	for(j=1;j<numy-1;j++)
		NODE_TYPE[j*numx]=1;	//main wall nodes
	NODE_TYPE[0]=6;  			//upper corner
	NODE_TYPE[(numy-1)*numx]=7;		//lower corner

// bottom boundry
	for(i=0;i<=numx+1;i++)
		BC[i+(numy+1)*(numx+2)]=3; // insulated
	for(i=1;i<numx-1;i++)
		NODE_TYPE[i+(numy-1)*numx]=2;
	NODE_TYPE[numx-1+(numy-1)*numx]=9;
	H[numx-1+(numy-1)*numx]=hval;

// top boundry
	k=0.01/dx;
	for(i=0;i<k+2;i++){
		BC[i]=3;			//top point insulated
	}
	for(j=0;j<0.01/dy;j++)  //set air temp
		for(i=k+2;i<=numx+1;i++){
			BC[i+j*(numx+2)]=1;
			temp[i+j*(numx+2)]=20;
		}
	j=0.01/dy;
	for(i=k+2;i<numx+1;i++){
		BC[i+j*(numx+2)]=2;  //convection
		H[i-1+j*numx]=hval;
		NODE_TYPE[i-1+j*numx]=0;
	}
	NODE_TYPE[k+j*numx]=5;
	H[k+j*numx]=hval;
	NODE_TYPE[numx-1+j*numx]=8;
	H[numx-1+j*numx]=hval;

// right boundry
	k=0.01/dy;
	i=0.01/dx;
	for(j=1;j<k;j++){
		temp[i+2+j*(numx+2)]=20;
		BC[i+2+j*(numx+2)]=2;   // convection
		NODE_TYPE[i+j*numx]=3;
		H[i+j*numx]=hval;
	}
	NODE_TYPE[k]=8;
	H[k]=hval;
	for(j=k+1;j<=numy;j++){
		temp[numx+1+j*(numx+2)]=20;
		BC[numx+1+j*(numx+2)]=2;   // convection
	}
	for(j=k+2;j<numy;j++){
		NODE_TYPE[numx-1+(j-1)*numx]=3;
		H[numx-1+(j-1)*numx]=hval;
	}


	k=0;
	for (j=1;j<=numy;j++)
		for(i=1;i<=numx;i++)
			if (BC[i+j*(numx+2)]==0)
				k+=1;
	num_unknowns=k;
	A=(double huge*) farmalloc((long) ((long) num_unknowns)*5*sizeof(double));
	ICOL=new int [num_unknowns*5];
	B=new double[num_unknowns];
	X=new double[num_unknowns];
	map= new int [num_unknowns*2] ; // (0);
	if ((map==NULL)||(A==NULL)||(B==NULL)||(X==NULL)||(ICOL==NULL))
		exit(1);

	for(i=0;i<num_unknowns*2;i++)
		*(map+i)=0;

// error 1 locale

	memset( map,0,(num_unknowns*sizeof(int)));
	memset( B,0,(num_unknowns*sizeof(double)));
	for(i=0;i<(num_unknowns*5);i++){
		*(A+i)=0.0;
		*(ICOL+i)=1;
	}





	for(i=0;i<num_unknowns;i++)
		*(X+i)=200.0;

	cnt=0;
	for(j=1;j<=numy;j++)
		for(i=1;i<=numx;i++){

			if(BC[(i)+(j)*(numx+2)]==0){
				if (NODE_TYPE[(i-1)+(j-1)*numx] != 5){
					switch(NODE_TYPE[(i-1)+(j-1)*numx]){
						case 0:
							mlty=0.5;
							mltx=1.0;
							break;
						case 1:
							mltx=0.5;
							mlty=1.0;
							break;
						case 2:
							mlty=0.5;
							mltx=1.0;
							break;
						case 3:
							mltx=0.5;
							mlty=1.0;
							break;
						case 4:
							mlty=mltx=1.0;
							break;
						case 6:
							mlty=mltx=0.5;
							break;
						case 7:
							mlty=mltx=0.5;
							break;
						case 8:
							mlty=mltx=0.5;
							break;
						case 9:
							mlty=mltx=0.5;
					}
					row=checkmap(i,j,map,cnt);
// check in horizontal direction
					tmp=i-1;
					switch (BC[(tmp)+j*(numx+2)]){
						case 2:  //convection
							B[row]-=H[(i-1)+(j-1)*numx]*
									temp[(tmp)+(j)*(numx+2)]*dy*mlty;
							A[0 + row*5]-=H[(i-1)+(j-1)*numx]*dy*mlty;
							break;
						
						case 0: //unknown temp
							tmp2=checkmap(tmp,j,map,cnt);
							A[fndpos(ICOL,row,tmp2) + 5*row]+=K[(i-1)+(j-1)*
															numx]*dy/dx*mlty;
							A[0 + 5*row]-=K[(i-1)+(j-1)*numx]*dy/dx*mlty;
							break;

						case 1: //known temp
							B[row]-=K[(i-1)+(j-1)*numx]*
									temp[(tmp)+(j)*(numx+2)]*dy/dx*mlty;
							A[0 + row*5]-=K[(i-1)+(j-1)*numx]*dy/dx*mlty;
					}

					tmp=i+1;
					switch (BC[(tmp)+j*(numx+2)]){
						case 2:  //convection
							B[row]-=H[(i-1)+(j-1)*numx]*
									temp[(tmp)+(j)*(numx+2)]*dy*mlty;
							A[0+row*5]-=H[(i-1)+(j-1)*numx]*dy*mlty;
							break;
	
						case 0: //unknown temp
							tmp2=checkmap(tmp,j,map,cnt);
							A[fndpos(ICOL,row,tmp2) + 5*row]+=K[(i-1)+(j-1)*
															numx]*dy/dx*mlty;
							A[0 + row*5]-=K[(i-1)+(j-1)*numx]*dy/dx*mlty;
							break;

						case 1: //known temp
							B[row]-=K[(i-1)+(j-1)*numx]*
									temp[(tmp)+(j)*(numx+2)]*dy/dx*mlty;
							A[0 + row*5]-=K[(i-1)+(j-1)*numx]*dy/dx*mlty;
					}
						
// check in vertical direction

					tmp=j-1;
					switch (BC[(i)+tmp*(numx+2)]){
						case 2:  //convection
							B[row]-=H[(i-1)+(j-1)*numx]*
									temp[(i)+(tmp)*(numx+2)]*dx*mltx;
							A[0 + row*5]-=H[(i-1)+(j-1)*numx]*dx*mltx;
							break;
								
						case 0: //unknown temp
							tmp2=checkmap(i,tmp,map,cnt);
							A[fndpos(ICOL,row,tmp2) + 5*row]+=K[(i-1)+(j-1)*
															numx]*dx/dy*mltx;
							A[0 + row*5]-=K[(i-1)+(j-1)*numx]*dx/dy*mltx;
							break;

						case 1: //known temp
							B[row]-=K[(i-1)+(j-1)*numx]*
									temp[(i)+(tmp)*(numx+2)]*dx/dy*mltx;
							A[0 + row*5]-=K[(i-1)+(j-1)*numx]*dx/dy*mltx;
					}
						
					tmp=j+1;
					switch (BC[(i)+tmp*(numx+2)]){
						case 2:  //convection
							B[row]-=H[(i-1)+(j-1)*numx]*
									temp[(i)+(tmp)*(numx+2)]*dx*mltx;
							A[0 + row*5]-=H[(i-1)+(j-1)*numx]*dx*mltx;
							break;
			
						case 0: //unknown temp
							tmp2=checkmap(i,tmp,map,cnt);
							A[fndpos(ICOL,row,tmp2) + 5*row]+=K[(i-1)+(j-1)*
															numx]*dx/dy*mltx;
							A[0 + row*5]-=K[(i-1)+(j-1)*numx]*dx/dy*mltx;
							break;
			
						case 1: //known temp
							B[row]-=K[(i-1)+(j-1)*numx]*
									temp[(i)+(tmp)*(numx+2)]*dx/dy*mltx;
							A[0 + row*5]-=K[(i-1)+(j-1)*numx]*dx/dy*mltx;
					}
				}
				else{
					row=checkmap(i,j,map,cnt);
// check in horizontal direction
					tmp=i-1; //left
					switch (BC[(tmp)+j*(numx+2)]){
						case 2:  //convection
							B[row]-=H[(i-1)+(j-1)*numx]*
									temp[(tmp)+(j)*(numx+2)]*dy;
							A[0 + row*5]-=H[(i-1)+(j-1)*numx]*dy;
							break;
						
						case 0: //unknown temp
							tmp2=checkmap(tmp,j,map,cnt);
							A[fndpos(ICOL,row,tmp2) + 5*row]+=K[(i-1)+(j-1)*
															numx]*dy/dx;
							A[0 + row*5]-=K[(i-1)+(j-1)*numx]*dy/dx;
							break;

						case 1: //known temp
							B[row]-=K[(i-1)+(j-1)*numx]*
									temp[(tmp)+(j)*(numx+2)]*dy/dx;
							A[0 + row*5]-=K[(i-1)+(j-1)*numx]*dy/dx;
					}

					tmp=i+1; //right
					switch (BC[(tmp)+j*(numx+2)]){
						case 2:  //convection
							B[row]-=H[(i-1)+(j-1)*numx]*
									temp[(tmp)+(j)*(numx+2)]*dy*0.5;
							A[0 + row*5]-=H[(i-1)+(j-1)*numx]*dy*0.5;
							break;
	
						case 0: //unknown temp
							tmp2=checkmap(tmp,j,map,cnt);
							A[fndpos(ICOL,row,tmp2) + 5*row]+=K[(i-1)+(j-1)*
															numx]*dy/dx*0.5;
							A[0 + row*5]-=K[(i-1)+(j-1)*numx]*dy/dx*0.5;
							break;
			
						case 1: //known temp
							B[row]-=K[(i-1)+(j-1)*numx]*
									temp[(tmp)+(j)*(numx+2)]*dy/dx*0.5;
							A[0 + row*5]-=K[(i-1)+(j-1)*numx]*dy/dx*0.5;
					}
						
// check in vertical direction

					tmp=j-1; //up
					switch (BC[(i)+tmp*(numx+2)]){
						case 2:  //convection
							B[row]-=H[(i-1)+(j-1)*numx]*
									temp[(i)+(tmp)*(numx+2)]*dx*0.5;
							A[0 + row*5]-=H[(i-1)+(j-1)*numx]*dx*0.5;
							break;
								
						case 0: //unknown temp
							tmp2=checkmap(i,tmp,map,cnt);
							A[fndpos(ICOL,row,tmp2) + 5*row]+=K[(i-1)+(j-1)*
															numx]*dx/dy*0.5;
							A[0 + row*5]-=K[(i-1)+(j-1)*numx]*dx/dy*0.5;
							break;

						case 1: //known temp
							B[row]-=K[(i-1)+(j-1)*numx]*
									temp[(i)+(tmp)*(numx+2)]*dx/dy*0.5;
							A[0 + row*5]-=K[(i-1)+(j-1)*numx]*dx/dy*0.5;
					}
						
					tmp=j+1; //down
					switch (BC[(i)+tmp*(numx+2)]){
						case 2:  //convection
							B[row]-=H[(i-1)+(j-1)*numx]*
									temp[(i)+(tmp)*(numx+2)]*dx;
							A[0 + row*5]-=H[(i-1)+(j-1)*numx]*dx;
							break;
			
						case 0: //unknown temp
							tmp2=checkmap(i,tmp,map,cnt);
							A[fndpos(ICOL,row,tmp2) + 5*row]+=K[(i-1)+(j-1)*
															numx]*dx/dy;
							A[0 + row*5]-=K[(i-1)+(j-1)*numx]*dx/dy;
							break;
			
						case 1: //known temp
							B[row]-=K[(i-1)+(j-1)*numx]*
									temp[(i)+(tmp)*(numx+2)]*dx/dy*mltx;
							A[0 + row*5]-=K[(i-1)+(j-1)*numx]*dx/dy;
					}
				// now take care of wierd corner
				tmp=i+1;
				tmp2=j-1;
				B[row]-=H[(i-1)+(j-1)*numx]*
							temp[(tmp)+(tmp2)*(numx+2)]*dx*0.5;
				A[0 + row*5]-=H[(i-1)+(j-1)*numx]*dx*0.5;
				B[row]-=H[(i-1)+(j-1)*numx]*
							temp[(tmp)+(tmp2)*(numx+2)]*dy*0.5;
				A[0 + row*5]-=H[(i-1)+(j-1)*numx]*dy*0.5;
				}
			}		
		}



//Dump Matrix to file


//	exit(1);

	time(&T1);
	solvemat(num_unknowns, A, X, B, ICOL);
	time(&T2);
	diff=difftime(T2,T1);
	printf("%i seconds", diff);
//	cout<< difftime(T2,T1)<<" seconds"<<endl;
	for(k=0;k<num_unknowns;k++)
		temp[map[k*2]+(numx+2)*map[1+k*2]]=X[k];

	delete X;
	delete B;
	farfree(A);
	delete ICOL;

// error 3 locale


// print temp at corners and at mid-points
	printf("\n\rNumber of Unknows  %10i", num_unknowns);

	printf("\n\rX co-ordinate  Y co-ordinate   temperature\n\r");
	format=    "  %-10.3f      %-10.3f           %-10.4f\n\r";
	printf(format,0.0,0.0,temp[1+1*(numx+2)]);
	printf(format,1.0,0.0,temp[1+(int (0.01/dx)) +1*(numx+2)]);
	printf(format,0.0,1.0,temp[1 +(int (0.01/dy)+1)*(numx+2)]);
	printf(format,1.0,1.0,temp[(1+(int (0.01/dx))) 
			+(int(0.01/dy)+1)*(numx+2)]);
	printf(format,6.0,1.0,temp[(1+(int (0.06/dx))) 
			+(int (0.01/dy)+1)*(numx+2)]);
	printf(format,0.0,2.0,temp[1 +(int (0.02/dy+1))*(numx+2)]);
	printf(format,6.0,2.0,temp[(1+(int (0.06/dx))) 
			+(int (0.02/dy)+1)*(numx+2)]);



// calculate heat in and heat out
	heat_in=heat_out=0.0;
	k=0.01/dy;
	i=0.01/dx;
	for(j=0;j<numy;j++){
		if( (j==0)||(j==(numy-1)) )
			heat_in+=500.0*dy*(400.0-temp[1+(j+1)*(numx+2)] )*0.5;
		else
			heat_in+=500.0*dy*(400.0-temp[1+(j+1)*(numx+2)] );
		if (j<k) {
			if(j==0)
				heat_out+=hval*dy*(temp[(i+1)+(j+1)*(numx+2)]-20.0)*0.5;
			else
				heat_out+=hval*dy*(temp[(i+1)+(j+1)*(numx+2)]-20.0);
		}
		if (j==k){
			heat_out+=hval*(dy+dx)/2.0*(temp[(i+1)+(j+1)*(numx+2)]-20.0);
			heat_out+=hval*(dy+dx)/2.0*(temp[(numx)+(j+1)*(numx+2)]-20.0);
		}
		if (j>k){
			if( (j==(k+1)) || (j==(numy-1)) )
				heat_out+=hval*dy*(temp[(numx)+(j+1)*(numx+2)]-20.0)*0.5;
			else
				heat_out+=hval*dy*(temp[(numx)+(j+1)*(numx+2)]-20.0);
		}
	}
	for(j=i+1;j<numx-1;j++)
		heat_out+=hval*dx*(temp[(j+1)+(k+1)*(numx+2)]-20);

	printf("\n\rHeat in     Heat out      Difference\n\r");
	printf("%-10.2f  %-10.2f     %-10.2f",heat_in,heat_out,
			(heat_in-heat_out) );



return 0;

}

int checkmap(int i,int j, int *map, int &count){
	int k;

	for(k=0;k<count;k++)
		if ((map[0+k*2]==i)&&(map[1+k*2]==j))
			break;
	if (k==count){
		map[k*2]=i;
		map[1+k*2]=j;
		count+=1;
	}
return k;
}

void solvemat(int n, double huge *a, double *x, double *b, int *ICOL){
	int i,j,j1;
	unsigned long maxiter, iter;
	double dfmin;
	double rhs, jend, df, alpha;

	dfmin=0.001;
	maxiter=((long) 200) * ((long) n);
	alpha=1.6;

	iter=0;
	df=10;
	while( (iter<maxiter) && (df>dfmin)){
		df=0.0;
		for(i=0;i<n;i++){
			rhs=(*(b+i)) - (*(a+i*5)) * (*(x+i));
			jend=*(ICOL+i*5);
			for(j=1;j<jend;j++){
				j1=*(ICOL+j+i*5);
				rhs-=(*(a+j+i*5)) * (*(x+j1));
			}
			df+=rhs<=0?(-1.0*rhs):rhs;
			(*(x+i))+=alpha*rhs/(*(a+i*5));
		}
		iter+=1;
	}
	printf("\n\r %5lu   Iterations\n\rConvergence =%10.3e\n\r",iter,df);
}

float XX(float x, float y, float z){
	return y*cos(AS)-x*sin(AS)*cos(AP)-z*sin(AS)*sin(AP);
}

float YY(float x, float y, float z){
	return x*sin(AP)-z*cos(AP);
}

int fndpos(int *ICOL,int row, int col){
	int i;

	for(i=1;i<ICOL[0+row*5];i++)
		if(col==ICOL[i+row*5])
			break;

	if(i==ICOL[0+row*5]){
		ICOL[i+row*5]=col;
		ICOL[0+row*5]+=1;
	}

	return i;
}
